package moreswing.swing.plaf

import javax.swing.SwingUtilities

import scala.swing.UIElement

/** Extends [[scala.swing.UIElement]] with redesign support.
 *
 * @author myst3r10n
*/
trait Redesign extends UIElement with RedesignListener {

  /** Add listener to [[scala.swingx.plaf.RedesignManager]]. */
  RedesignManager += this

  /** Called by [[scala.swingx.plaf.RedesignManager]] if redesigned. */
  def redesigned { SwingUtilities.updateComponentTreeUI(this.peer) }

}
