package moreswing.swing.plaf

import java.awt.Toolkit

import javax.swing. { JDialog, JFrame, JOptionPane, UIManager }
import javax.swing.UIManager.LookAndFeelInfo

import scala.collection.mutable.Buffer
import scala.ref.WeakReference

/** Manage redesign.
 *
 * @author myst3r10n
 */
object RedesignManager {

  def +=(listener: RedesignListener) {

    listeners += new WeakReference(listener)
    listener.redesigned

  }

  protected var _laf = new LookAndFeelInfo(
    "MetalLookAndFeel",
    "javax.swing.plaf.metal.MetalLookAndFeel")

  def laf = _laf

  def laf_= (laf: LookAndFeelInfo) {

    _laf = laf

    UIManager.setLookAndFeel(laf.getClassName)

    listeners.foreach { listener =>

      if(listener.get.orNull != null)
      	listener.get.get.redesigned
      else
      	listeners.remove(listeners.indexWhere(l => l.get == listener.get))

    }

  }

  private var listeners = Buffer[WeakReference[RedesignListener]]()

}

